OpenShot Audio Library | OpenShotAudio: juce::ScopedTryReadLock Class Reference

OpenShot Audio Library | OpenShotAudio 0.4.0 |

Loading...
Searching...
No Matches
Public Member Functions | List of all members
juce::ScopedTryReadLock Class Reference

`#include <juce_ScopedReadLock.h>`

## Public Member Functions
| ScopedTryReadLock (ReadWriteLock &lockIn)
| ScopedTryReadLock (ReadWriteLock &lockIn, bool acquireLockOnInitialisation) noexcept
| ~ScopedTryReadLock () noexcept
bool | isLocked () const noexcept
bool | retryLock () noexcept

## Detailed Description

Automatically locks and unlocks a ReadWriteLock object.

Use one of these as a local variable to control access to a ReadWriteLock.

e.g.

ReadWriteLock myLock;
for (;;)
{
const ScopedTryReadLock myScopedTryLock (myLock);
// Unlike using a ScopedReadLock, this may fail to actually get the lock, so you
// should test this with the isLocked() method before doing your thread-unsafe
// action.
if (myScopedTryLock.isLocked())
{
...do some stuff...
}
else
{
..our attempt at locking failed because a write lock has already been issued..
}
// myLock gets unlocked here (if it was locked).
}
juce::ReadWriteLock
Definition juce_ReadWriteLock.h:48
juce::ScopedTryReadLock::ScopedTryReadLock
ScopedTryReadLock(ReadWriteLock &lockIn)
Definition juce_ScopedReadLock.h:131

See also
  ReadWriteLock, ScopedTryWriteLock

Definition at line 119 of file juce_ScopedReadLock.h.

## Constructor & Destructor Documentation

## ◆ ScopedTryReadLock() [1/2]

juce::ScopedTryReadLock::ScopedTryReadLock | ( | ReadWriteLock & | lockIn | ) |
| inlineexplicit

Creates a ScopedTryReadLock and calls ReadWriteLock::tryEnterRead() as soon as it is created. When the ScopedTryReadLock object is destructed, the ReadWriteLock will be unlocked (if it was successfully acquired).

Make sure this object is created and destructed by the same thread, otherwise there are no guarantees what will happen! Best just to use it as a local stack object, rather than creating one with the new() operator.

Definition at line 131 of file juce_ScopedReadLock.h.

Referenced by ScopedTryReadLock().

## ◆ ScopedTryReadLock() [2/2]

juce::ScopedTryReadLock::ScopedTryReadLock | ( | ReadWriteLock & | lockIn,
|  | bool | acquireLockOnInitialisation )
| inlinenoexcept

Creates a ScopedTryReadLock.

If acquireLockOnInitialisation is true then as soon as it is created, this will call ReadWriteLock::tryEnterRead(), and when the ScopedTryReadLock object is destructed, the ReadWriteLock will be unlocked (if it was successfully acquired).

Make sure this object is created and destructed by the same thread, otherwise there are no guarantees what will happen! Best just to use it as a local stack object, rather than creating one with the new() operator.

Definition at line 144 of file juce_ScopedReadLock.h.

## ◆ ~ScopedTryReadLock()

juce::ScopedTryReadLock::~ScopedTryReadLock | ( |  | ) |
| inlinenoexcept

Destructor.

The ReadWriteLock's exitRead() method will be called when the destructor is called.

Make sure this object is created and destructed by the same thread, otherwise there are no guarantees what will happen!

Definition at line 154 of file juce_ScopedReadLock.h.

## Member Function Documentation

## ◆ isLocked()

bool juce::ScopedTryReadLock::isLocked | ( |  | ) | const
| inlinenoexcept

Returns true if the mutex was successfully locked.

Definition at line 157 of file juce_ScopedReadLock.h.

Referenced by juce::ARAAudioSourceReader::readSamples(), and juce::ARAPlaybackRegionReader::readSamples().

## ◆ retryLock()

bool juce::ScopedTryReadLock::retryLock | ( |  | ) |
| inlinenoexcept

Retry gaining the lock by calling tryEnter on the underlying lock.

Definition at line 160 of file juce_ScopedReadLock.h.

The documentation for this class was generated from the following file:

- juce_ScopedReadLock.h